local Sushi = LibStub('Sushi-2.0')
local Button = Sushi:GetClass('Button')
local Check, old = Sushi:NewWidgetClass('CheckButton', {
	frameType = 'CheckButton',
	template = 'InterfaceOptionsCheckButtonTemplate',
	insets = {left = 10, right = 20},
	width = 150, height = 34,
	version = 1,
})

if not Check then
	return
end


--[[ Events ]]--

function Check:OnCreate()
	self:SetFontString(_G[self:GetName()..'Text'])
	self.SetValue = self.SetChecked
	self.GetValue = self.GetChecked
	
	Button.OnCreate(self)
end

function Check:OnRelease()
	Button.OnRelease(self)
	self:SetChecked(nil)
end

function Check:OnClick()
	local checked = self:GetChecked()
	if checked then
		PlaySound('igMainMenuOptionCheckBoxOn')
	else
		PlaySound('igMainMenuOptionCheckBoxOff')
	end
	
	self:FireCallback('OnValueChanged', checked)
	self:FireCallback('OnClick', checked)
	self:FireCallback('OnUpdate')
end


--[[ Small ]]--

function Check:SetSmall(small)
	if small then
		self:SetDisabledFontObject('GameFontDisableSmall')
		self:SetNormalFontObject('GameFontHighlightSmall')
	else
		self:SetDisabledFontObject('GameFontDisable')
		self:SetNormalFontObject('GameFontHighlight')
	end
end

function Check:IsSmall()
	return self:GetNormalFontObject() == 'GameFontHighlightSmall'
end


--[[ Embbedding ]]--

if not old then
	Button:Embed(Check, 'OnCreate', 'OnRelease', 'OnClick', 'SetText', 'SetSmall', 'IsSmall')
else
	Check:UpdateEmbeds()
end